def Fq(σ, σx, σp, γ11, γ12):
    """QFI from the joint state of the two detectors prepared in vacuum."""
    aux0 = (-2.0 * ((σ**4.0) * (((γ12 + (2.0 * (γ12 * (σx**2)))) ** 2)))) + (
        ((σp + (2.0 * (σp * (σx**2)))) ** 2)
    )
    aux1 = (γ11**2) * (
        (σx**2) + ((σx**4.0) + (((σp**4.0) * (((1.0 + (2.0 * (σx**2))) ** 2))) + aux0))
    )
    aux2 = ((σ**4.0) * (((γ12 + (2.0 * (γ12 * (σx**2)))) ** 2))) + (
        ((σp + (2.0 * (σp * (σx**2)))) ** 2)
    )
    aux3 = (γ12**2) * (
        (σx**2) + ((σx**4.0) + (((σp**4.0) * (((1.0 + (2.0 * (σx**2))) ** 2))) + aux2))
    )
    aux4 = (
        (γ11**3.0) * ((1.0 + (2.0 * (σp**2))) * (((σ + (2.0 * (σ * (σx**2)))) ** 2)))
    ) + (aux1 + aux3)
    aux5 = (((γ11**4.0) * ((σ**4.0) * (((1.0 + (2.0 * (σx**2))) ** 2)))) + aux4) - (
        γ11
        * (
            (γ12**2)
            * ((σ**2) * ((1.0 + (2.0 * (σp**2))) * (((1.0 + (2.0 * (σx**2))) ** 2))))
        )
    )
    aux6 = ((γ11 + γ12) * (σ**2)) + (
        (σp**2) + ((σx**2) + (2.0 * ((((γ11 + γ12) * (σ**2)) + (σp**2)) * (σx**2))))
    )
    aux7 = ((γ11 + γ12) * (σ**2)) + (
        (σp**2) + ((σx**2) + (2.0 * ((((γ11 + γ12) * (σ**2)) + (σp**2)) * (σx**2))))
    )
    aux8 = ((γ11 - γ12) * (σ**2)) + (
        (σp**2) + ((σx**2) + (2.0 * ((((γ11 - γ12) * (σ**2)) + (σp**2)) * (σx**2))))
    )
    aux9 = ((γ11 - γ12) * (σ**2)) + (
        (σp**2) + ((σx**2) + (2.0 * ((((γ11 - γ12) * (σ**2)) + (σp**2)) * (σx**2))))
    )
    output = (
        (((4.0 * ((((σ + (2.0 * (σ * (σx**2)))) ** 2)) * aux5)) / (1.0 + aux6)) / aux7)
        / (1.0 + aux8)
    ) / aux9
    return output


def Fc(σ, σx, σp, γ11, γ12):
    """CFI from the joint distribution from quadrature measurements of the two detectors prepared in vacuum.
    This is not the CFI from product distribution which requires the Bessel K function.
    """
    aux0 = (
        (((γ11 - γ12) ** 2))
        * ((1.0 + ((2.0 * ((γ11 - γ12) * (σ**2))) + (2.0 * (σp**2)))) ** -2.0)
    ) + (
        (((γ11 + γ12) ** 2))
        * ((1.0 + ((2.0 * ((γ11 + γ12) * (σ**2))) + (2.0 * (σp**2)))) ** -2.0)
    )
    output = 8.0 * ((σ**2) * aux0)
    return output
